874c955982f0ab47120399a1e38b711dbddbf5c9
[xfstests-dev.git] / tests / generic / 045
1 #! /bin/bash
2 # FSQA Test No. 045
3 #
4 # Test for NULL files problem
5 #
6 #-----------------------------------------------------------------------
7 # Copyright (c) 2006 Silicon Graphics, Inc.  All Rights Reserved.
8 #
9 # This program is free software; you can redistribute it and/or
10 # modify it under the terms of the GNU General Public License as
11 # published by the Free Software Foundation.
12 #
13 # This program is distributed in the hope that it would be useful,
14 # but WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the GNU General Public License
19 # along with this program; if not, write the Free Software Foundation,
20 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
21 #
22 #-----------------------------------------------------------------------
23 #
24
25 seq=`basename $0`
26 seqres=$RESULT_DIR/$seq
27 echo "QA output created by $seq"
28
29 here=`pwd`
30 tmp=/tmp/$$
31 status=1    # failure is the default!
32 trap "exit \$status" 0 1 2 3 15
33
34 # get standard environment, filters and checks
35 . ./common/rc
36 . ./common/filter
37
38 # real QA test starts here
39 _supported_fs generic
40 _supported_os Linux IRIX
41
42 _require_scratch
43 _require_scratch_shutdown
44 _require_fiemap
45 _scratch_mkfs >/dev/null 2>&1
46 _scratch_mount
47
48 # create files
49 i=1;
50 while [ $i -lt 1000 ]
51 do
52         file=$SCRATCH_MNT/$i
53         $XFS_IO_PROG -f -c "pwrite -b 64k -S 0xff 0 64k" $file > /dev/null
54         if [ $? -ne 0 ]
55         then
56                 echo error creating/writing file $file
57                 exit
58         fi
59         $XFS_IO_PROG -c "truncate 32k" $file > /dev/null
60         if [ $? -ne 0 ]
61         then
62                 echo error truncating file $file
63                 exit
64         fi
65         let i=$i+1
66 done
67
68 # give the system a chance to write something out
69 sleep 10
70
71 src/godown $SCRATCH_MNT
72
73 _scratch_unmount
74 _scratch_mount
75 _scratch_unmount
76 if [ ! _check_scratch_fs ]
77 then
78         echo error detected in filesystem
79         exit
80 fi
81 _scratch_mount
82
83 # check file size and contents
84 i=1;
85 while [ $i -lt 1000 ]
86 do
87         file=$SCRATCH_MNT/$i
88         # if file does not exist, the create was not logged, skip it
89         if [ -e $file ]
90         then
91                 # if file size is zero it cannot be corrupt, skip it
92                 if [ -s $file ]
93                 then
94                         # if file has non-zero size but no extents then it's contents will be NULLs, bad.
95                         num_extents=`_count_extents $file`
96                         num_holes=`_count_holes $file`
97                         if [ $num_extents -eq 0 ]; then
98                                 echo corrupt file $file - non-zero size but no extents
99                         elif [ $num_holes -ne 0 ]; then
100                                 echo corrupt file $file - contains holes
101                         else
102                                 rm -f $file
103                         fi
104                 else
105                         rm -f $file
106                 fi
107         fi
108         let i=$i+1
109 done
110
111 status=0
112 exit